﻿#include "StdAfx.h"
#include "GameTalkAPIGlobal.h"
#include "WASGetEmployeeInfo.h"
#include "ConvertUTF.h"
#include "MessengerActor.h"
#include "UtilFunction.h"
#include "GameTalkAPIGlobal.h"

CWASGetEmployeeInfo::CWASGetEmployeeInfo(CWASActor *pActor)
	: CWASCommand(pActor)
{
    m_reqEmpInfoType = reitLogin;
    m_nGroupID = 0;
}

CWASGetEmployeeInfo::~CWASGetEmployeeInfo(void)
{
}

void CWASGetEmployeeInfo::ExecuteAsync()
{
	OutputDebugString( _T("CWASGetEmployeeInfo::ExecuteAsync ===================================\n") );

	m_listResultPrivate.clear();

	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if (pMessengerActor == NULL)
	{
		return;
	}	

	USES_UTF8_CONVERSION;

	WSTRING strURL = m_pActor->GetWASServerAddress();
	strURL += _T("/ne/emp/GetEmployeeInfo.php");

	m_httpFacade.session().SetURL( W2U8(strURL.c_str()), pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().SetMethod(HTTP_METHOD_POST);

	m_httpFacade.session().AddBodyVariable("userid", W2U8(pMessengerActor->GetUserID()));
	m_httpFacade.session().AddBodyVariable("ticket", pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().AddBodyVariable("empids", W2U8(m_strEmpIDs.c_str()));
	m_httpFacade.session().AddBodyVariable("function_list", W2U8(m_strFunction.c_str()));
	m_httpFacade.session().AddBodyVariable("langcode", W2U8(m_strLangCode.c_str()));

	m_httpFacade.session().SetKeepRawHeader(TRUE);
	m_httpFacade.SendRequest(this);

}
bool CWASGetEmployeeInfo::ParseAndEventFire(nfc::CIkXMLDom * pDom)
{
	if(pDom == NULL)
		return false;

	nfc::IIkXMLNode* pNode = pDom->GetdocumentElement()->selectSingleNode("nodes");
	if (pNode == NULL)
	{
		m_strWasErrMsg += _T("검색 데이터에서 \" <nodes>\" 를 찾을 수 없습니다.");
		return false;
	}

	nfc::IIkXMLNodeList *pList = pNode->selectNodes("node");	
	nfc::IIkXMLAttribute* pAttr;
	USES_UTF8_CONVERSION;
	m_listResultPrivate.clear();

	for (int i = 0; i < pList->Getlength(); i++)
	{	
		NE_MEMBER_DATA sResultPrivate;// 매번 새로 초기화
		pNode = pList->Getitem(i);
		GT_ASSERT(pNode);

		if (NULL == (pAttr = pNode->getAttribute("user_id")))// 필수
			continue;	// ignore this item

		sResultPrivate.strUserId = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("emp_nm")))
			sResultPrivate.strName = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("emp_nm_us")))
			sResultPrivate.strNameUS = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("emp_nm_kr")))
			sResultPrivate.strNameKR = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("emp_nm_tw")))
			sResultPrivate.strNameTW = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("emp_nm_jp")))
			sResultPrivate.strNameJP = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("emp_nm_cn")))
			sResultPrivate.strNameCN = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("dept_nm")))
			sResultPrivate.strDept = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("jbps_nm")))
			sResultPrivate.strJobPos = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("jbps_cd")))
			sResultPrivate.strJobPosCd = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("jbdt_nm")))
			sResultPrivate.strJobDuty = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("jbdt_cd")))
			sResultPrivate.strJobDutyCd = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("inco_tel_no")))		// 내선번호
			sResultPrivate.strExtesion = U82W(pAttr->Gettext().c_str());
		
		if (NULL != (pAttr = pNode->getAttribute("tel_no")))			// 회사번호
			sResultPrivate.strIncoTel = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("fax_no")))
			sResultPrivate.strFaxNum = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("cph_no")))
			sResultPrivate.strCellPhone = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("ipph_no")))
			sResultPrivate.strIPPhone = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("email_addr")))
			sResultPrivate.strEmail = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("rmngph_no")))
			sResultPrivate.strRmngPhone = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("kwd_nm")))
			sResultPrivate.strKeyword = U82W(pAttr->Gettext().c_str());
		
		if (NULL != (pAttr = pNode->getAttribute("nickname")))
			sResultPrivate.strNickName = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("work_place")))
			sResultPrivate.strWorkPlace = U82W(pAttr->Gettext().c_str());
		
		if (NULL != (pAttr = pNode->getAttribute("work_status")))
			sResultPrivate.strWorkStatus = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("photo_url")))
			sResultPrivate.strPhotoURL = U82W(pAttr->Gettext().c_str());

		if( NULL != (pAttr = pNode->getAttribute("add_info_cont")))
		{
			sResultPrivate.strAddInfoCont = U82W(pAttr->Gettext().c_str());
		}


		m_listResultPrivate.push_back(sResultPrivate);
	}

	return true;

}




// override in drived class
void CWASGetEmployeeInfo::OnWasResponse(trid_t trid,
									   bool bSuccess,
									   int /*nWinINetErrorCode*/, 
									   int /*nHttpResponseCode*/, 
									   LPCSTR /*szWasResCodeInHeader*/, 
									   LPCSTR szWasResCodeInXml,
									   nfc::CIkXMLDom * pDom)
{
	OutputDebugString( _T("CWASGetEmployeeInfo::OnWasResponse ===================================\n") );

	if(bSuccess)
	{
		if(ParseAndEventFire(pDom) == false)
			m_eError = wasError_Protocol;
	}

	GT_ASSERT(m_pActor);

	NE_MEMBER_DATA_LIST sList;
	sList.nSize = m_listResultPrivate.size();
	sList.pList = sList.nSize > 0 ? &m_listResultPrivate[0] : NULL;

	if( m_reqEmpInfoType == reitSingleTrans )
	{
		//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
		//EnterCriticalSection(pCS);

		CGTObserved<IGTWASActorEvent>::listobserver_t observers;
		m_pActor->GetObservers(&observers);
		CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();

		for (; it != observers.end(); ++it)
		{		
			IGTWASActorEvent *pObserver = static_cast<IGTWASActorEvent *>(*it);

			pObserver->OnGTWASActor_ResponseGetEmployeeInfo(m_pActor, GetID(), m_eError, sList, m_reqEmpInfoType, m_nGroupID);
		}

		//LeaveCriticalSection(pCS);
	}
	else
	{
		CGTObserved<IGTWASActorEventPrivate>::listobserver_t observers;
		m_pActor->GetObserversEx(&observers);
		CGTObserved<IGTWASActorEventPrivate>::listobserver_t::iterator it = observers.begin();

		for (; it != observers.end(); ++it)
		{
			IGTWASActorEventPrivate *pObserver = static_cast<IGTWASActorEventPrivate *>(*it);
			pObserver->OnGTWASActor_ResponseGetEmployeeInfo(m_pActor, GetID(), m_eError, sList, m_reqEmpInfoType, m_nGroupID);
		}
	}

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}


void CWASGetEmployeeInfo::OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/)
{
	m_eError = wasError_Timeout;

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();

	NE_MEMBER_DATA_LIST sList;
	sList.nSize = m_listResultPrivate.size();
	sList.pList = sList.nSize > 0 ? &m_listResultPrivate[0] : NULL;

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEvent *pObserver = static_cast<IGTWASActorEvent *>(*it);
		pObserver->OnGTWASActor_ResponseGetEmployeeInfo(m_pActor, GetID(), m_eError, sList, m_reqEmpInfoType, m_nGroupID);
	}

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}
